open AbstractSyntax

(* ------------------------------------------------------------------------- *)

(* The constraint generator is parameterized over a data constructor
   table and a main expression. It produces a unification problem with
   a distinguished variable (which represents the type of the main
   expression). *)

module Run (G : sig

  val dcenv: Wf.data_constructor_table
  val main: expression

end) : sig

  val problem: Unification.problem
  val root: Unification.variable

end = struct

open G

(* ------------------------------------------------------------------------- *)

(* The constraint generator builds a unification problem. *)

module B =
  Unification.Build (struct end)

open B

(* ------------------------------------------------------------------------- *)

(* The constraint generator maintains a mapping [vvenv] of value
   variables to internal types (that is, unification terms) and a
   mapping [tvenv] of external type variables to internal type
   variables (that is, unification variables). *)

type vvenv =
   Unification.term StringMap.t

type tvenv =
   Unification.variable StringMap.t

(* ------------------------------------------------------------------------- *)

(* The constraint generator accepts two environments [vvenv] and
   [tvenv], an expression [e], and an expected type [expected]. It
   (implicitly) emits a constraint and returns no explicit result. *)

let rec type_expr
    (vvenv : vvenv) (tvenv : tvenv)
    (e : expression) (expected : Unification.term) =
  () (* INCOMPLETE! of course something should be done here... *)

(* ------------------------------------------------------------------------- *)

(* To conclude, apply the generator to the main expression and extract the
   resulting unification problem. *)

let root =
  fresh()

let problem =
  type_expr StringMap.empty StringMap.empty main (TVar root);
  finished()

end
