open Printf
open Print
open AbstractSyntax

let rec lift f = function
  | TVar x ->
      f x
  | TArrow (t1, t2) ->
      TArrow (lift f t1, lift f t2)
  | TConApp (dc, ts) ->
      TConApp (dc, List.map (lift f) ts)

let rec print0 pv b = function
  | TVar v ->
      pv b v
  | TConApp (tc, []) ->
      bprintf b "%s" tc
  | TConApp (tc, [ t ]) ->
      bprintf b "%a %s" (print0 pv) t tc
  | TConApp (tc, ts) ->
      bprintf b "(%a) %s" (seplist comma (print0 pv)) ts tc
  | t ->
      bprintf b "(%a)" (print pv) t

and print pv b = function
  | TArrow (t0, t1) ->
      bprintf b "%a -> %a" (print0 pv) t0 (print pv) t1
  | t ->
      print0 pv b t

